import type { AnyObject } from './types';
type OptionalPropertyNames<T> = {
    [K in keyof T]-?: AnyObject extends {
        [P in K]: T[K];
    } ? K : never;
}[keyof T];
type SpreadProperties<L, R, K extends keyof L & keyof R> = {
    [P in K]: L[P] | Exclude<R[P], undefined>;
};
type Id<T> = T extends infer U ? {
    [K in keyof U]: U[K];
} : never;
type SpreadTwo<L, R> = Id<Pick<L, Exclude<keyof L, keyof R>> & Pick<R, Exclude<keyof R, OptionalPropertyNames<R>>> & Pick<R, Exclude<OptionalPropertyNames<R>, keyof L>> & SpreadProperties<L, R, OptionalPropertyNames<R> & keyof L>>;
type Assign<A extends readonly [...any]> = A extends [infer L, ...infer R] ? SpreadTwo<L, Assign<R>> : unknown;
/**
 * assigns properties of one or more source objects onto target object
 * @example
 * assign({ a: 1, b: 2 }, { b: 4, c: 5 })
 * // returns { a: 1, b: 4, c: 5 }
 */
export default function assign<T extends AnyObject[]>(...args: [...T]): Assign<T>;
export {};
//# sourceMappingURL=assign.d.ts.map