/**
 * recurses through an object and transforms its keys – and the keys of any nested objects – based on the provided key mapping function
 * @example
 * deepMapKeys(key => `test_${key}`, { a: 1, b: { c: 2 } })
 * // returns { test_a: 1, test_b: { test_c: 2 } }
 */
export default function deepMapKeys<T>(mapper: (key: string) => string, obj: Record<string, any>): T;
//# sourceMappingURL=deepMapKeys.d.ts.map