/**
 * returns a function that invoked with a null or undefined values returns the provided default
 * @example
 * const defaulter = defaultTo('default')
 * defaulter('hello')
 * // returns 'hello'
 * defaulter(null)
 * // returns 'default'
 */
export default function defaultTo<T>(defaultValue: T): <V>(value: V) => V extends null | undefined ? T : V;
//# sourceMappingURL=defaultTo.d.ts.map