import type { AnyObject } from './types';
type Diff<T, C> = {
    [Key in keyof T as Key extends keyof C ? T[Key] extends C[Key] ? C[Key] extends T[Key] ? never : never : Key : Key]: unknown;
};
/**
 * returns an array of keys of the object passed as the first argument that are not present, or that are present, but have different values, in object passed as the second argument
 * @example
 * diffKeys({ a: 1, b: 2, c: 3 }, { c: 3, d: 4 })
 * // returns ['a', 'b']
 */
export default function diffKeys<T extends AnyObject, C extends AnyObject>(obj: T, comparable: C): Array<keyof Diff<T, C>>;
export {};
//# sourceMappingURL=diffKeys.d.ts.map