import type { AnyObject } from './types';
/**
 * returns an array of entries of the provided object
 * @example
 * entries({ a: 1, b: 2 })
 * // returns [['a', 1], ['b', 2]]
 */
export default function entries<T extends AnyObject>(obj: T): Array<{
    [K in keyof T]: [K, T[K]];
}[keyof T]>;
//# sourceMappingURL=entries.d.ts.map