import type { AnyObject } from './types';
/**
 * returns the key of the provided object that returns true for the predicate function, or undefined if the key was not found
 * @example
 * findKey(el => el === 1, { a: 1, b: { c: 2 } })
 * // returns 'a'
 * findKey(el => el === 2, { a: 1, b: { c: 2 } })
 * // returns undefined
 */
export default function findKey<T extends AnyObject, K extends keyof T>(predicate: (el: T[K]) => boolean, obj: T): K | undefined;
//# sourceMappingURL=findKey.d.ts.map