/**
 * returns a new array formed by applying a given callback function to each element of the array, and then flattening the result by one level
 * @example
 * const arr = [{ a: [1, 2] }, { a: [3, 4] }, { a: [5, 6] }]
 * flatMap(el => el.a, arr)
 * // returns [1, 2, 3, 4, 5, 6]
 */
export default function flatMap<T, R>(iteratee: (el: T) => R[], arr: T[]): R[];
//# sourceMappingURL=flatMap.d.ts.map