import type { AnyObject } from './types';
type IndexerCallback<T extends {
    [key: string]: any;
}> = (val: T[keyof T], key: keyof T) => any;
/**
 * invokes the provided callback for each of the provided object fields
 * @example
 * const obj = { a: 1, b: 2, c: 3 }
 * const arr: string[] = []
 * forOwn(el => arr.push(el.toString()), obj)
 * // arr equals ['1', '2', '3']
 */
export default function forOwn<T extends AnyObject>(callback: IndexerCallback<T>, obj: T): void;
export {};
//# sourceMappingURL=forOwn.d.ts.map