/**
 * returns an object constructed from the provided array of key, value pairs'
 * @example
 * const arr = [['a', 1], ['b', 2], ['c', 3]]
 * fromPairs(arr)
 * // returns { a: 1, b: 2, c: 3 }
 */
export default function fromPairs<T extends ReadonlyArray<readonly [PropertyKey, any]>>(pairs: T): {
    [K in T[number] as K[0]]: K[1];
};
//# sourceMappingURL=fromPairs.d.ts.map