import type { Get } from './get';
/**
 * returns the value from the specififed path from the provided object or the default value if the path element was not found
 * @example
 * const obj = { a: { b: [1, 2, 3] } }
 * getOr(null, 'a.b.1', obj)
 * // returns 2
 * getOr(null, 'a.c', obj)
 * // returns null
 */
export default function getOr<Default, Path extends string | readonly string[], Obj>(defaultValue: Default, prop: Path, obj: Obj): Get<Obj, Path, Default>;
//# sourceMappingURL=getOr.d.ts.map