import type { AnyObject } from './types';
/**
 * returns true or false depending if the provided property is present inside the provided object
 * @example
 * hasOwn('a', { a: 1, b: 2 })
 * // returns true
 */
export default function hasOwn<Obj extends AnyObject, Own extends keyof Obj, Prop extends PropertyKey>(prop: Prop, obj: Obj): Prop extends Own ? true : false;
//# sourceMappingURL=hasOwn.d.ts.map