/**
 * ensures that a function is executed at a fixed interval, so that it is not called too frequently
 * @example
 * const updatePreview = () => { ... }
 * const throttledUpdatePreview = leadingThrottle(updatePreview, 500);
 * inputField.addEventListener('input', throttledUpdatePreview);
 */
export default function leadingThrottle<T extends (...args: any[]) => any>(ms: number, fn: T): (...args: Parameters<T>) => void;
//# sourceMappingURL=leadingThrottle.d.ts.map