import type { AnyObject } from './types';
type IncludesSubstring<T, S> = T extends `${string}${string & S}` ? T : T extends `${string & S}${string}` ? T : T extends `${string}${string & S}${string}` ? T : never;
/**
 * maps keys of the provided object
 * @example
 * mapKeys(key => key.toUpperCase(), { a: 1, b: 2 })
 * // returns { A: 1, B: 2 }
 */
export default function mapKeys<T extends AnyObject, K extends string, StaticKeyResult = {
    [Key in keyof T as IncludesSubstring<K, Key>]: T[Key];
}, Result = keyof StaticKeyResult extends never ? {
    [key in keyof T as K]: T[key];
} : StaticKeyResult>(mapper: (key: keyof T) => K, obj: T): Result;
export {};
//# sourceMappingURL=mapKeys.d.ts.map