import type { AnyObject } from './types';
/**
 * maps values of the provided object
 * @example
 * mapValues(val => val.toUpperCase(), { a: 'foo', b: 'bar' })
 * // returns { a: 'FOO', b: 'BAR' }
 */
export default function mapValues<T extends AnyObject, R>(mapper: (value: T[keyof T]) => R, obj: T): {
    [key in keyof T]: R;
};
//# sourceMappingURL=mapValues.d.ts.map