import type { AnyObject } from './types';
/**
 * maps values and keys of the provided object
 * @example
 * mapValuesIndexed((val, key) => `${key}-${val}`, { a: 1, b: 2 })
 * // returns { a: 'a-1', b: 'b-2' }
 */
export default function mapValuesIndexed<T extends AnyObject, R>(iteratee: (val: T[keyof T], key: keyof T) => R, obj: T): {
    [K in keyof T]: R;
};
//# sourceMappingURL=mapValuesIndexed.d.ts.map