/**
 * sorts values of the provided object or array based on the provided mapping function or the provided prop string
 * @example
 * const obj = {
 * 	a: { chats: 1 },
 * 	b: { chats: 3 },
 * 	c: { chats: 2 },
 * }
 * numericSortBy(el => el.chats * -1, obj)
 * // returns [{ chats: 3 }, { chats: 2 }, { chats: 1 }]
 */
export default function numericSortBy<T>(propOrMapper: string | string[] | ((el: T) => number), collection: Record<string, T> | T[]): T[];
//# sourceMappingURL=numericSortBy.d.ts.map