import type { AnyObject } from './types';
/**
 * returns an object same as the provided one but without the fields omitted by the predicate function
 * @example
 * omitBy(el => el % 2 === 0, { a: 1, b: 2, c: 3 })
 * // returns { a: 1, c: 3 }
 */
export default function omitBy<O, T extends AnyObject>(predicate: (el: T[keyof T]) => boolean, obj: T): O;
//# sourceMappingURL=omitBy.d.ts.map