import type { AnyObject } from './types';
/**
 * returns an object the same as the provided one but without the fields omitted by the predicate function
 * @example
 * omitByIndexed((val, key) => key === 'b', { a: 1, b: 2, c: 3 })
 * // returns { a: 1, c: 3 }
 */
export default function omitByIndexed<O, T extends AnyObject>(predicate: (el: T[keyof T], key: keyof T) => boolean, obj: T): O;
//# sourceMappingURL=omitByIndexed.d.ts.map