import type { AnyFunction } from './types';
/**
 * returns a particular function to be executed only a single time
 * @example
 * const results = [1, 2, 3, 4, 5]
 * const getResult = once(() => results.pop())
 * getResult() // 5
 * getResult() // 5
 * getResult() // 5
 *
 */
export default function once<T extends AnyFunction>(fn: T): (...args: Parameters<T>) => ReturnType<T>;
//# sourceMappingURL=once.d.ts.map