import type { AnyFunction } from './types';
/**
 * returns a function that called invokes the provided array of functions with the call arguments
 * @example
 * const func = over([val => val + 1, val => val * 10, Boolean])
 * func(1)
 * // returns [2, 10, true]
 */
export default function over<T extends AnyFunction>(fns: T[]): (...args: any[]) => ReturnType<T>[];
//# sourceMappingURL=over.d.ts.map