import type { AnyObject } from './types';
/**
 * returns a tuple of valid and invalid parts of the object as defined in validation function passed in the first argument
 * @example
 * partitionObject(el => el % 2 === 0, { a: 1, b: 2, c: 3 })
 * // returns [{ b: 2 }, { a: 1, c: 3 }]
 */
export default function partitionObject<Obj extends AnyObject, Res1 extends {
    [K in keyof Obj]: Obj[keyof Obj];
}, Res2 extends {
    [K in keyof Obj]: Obj[keyof Obj];
}>(predicate: (el: Obj[keyof Obj]) => boolean, obj: Obj): [Res1, Res2];
//# sourceMappingURL=partitionObject.d.ts.map