import type { AnyObject } from './types';
/**
 * returns an object same as the provided one but with the fields picked by the predicate function
 * @example
 * pickBy(el => el % 2 === 0, { a: 1, b: 2, c: 3 })
 * // returns { b: 2 }
 */
export default function pickBy<T extends AnyObject, R extends {
    [key in keyof T]: T[keyof T];
}>(predicate: (el: T[keyof T]) => boolean, obj: T): R;
//# sourceMappingURL=pickBy.d.ts.map