import type { AnyObject } from './types';
/**
 * returns an object same as the provided one but with the fields picked by the predicate function
 * @example
 * pickByIndexed((val, key) => key === 'b', { a: 1, b: 2, c: 3 })
 * // returns { b: 2 }
 */
export default function pickByIndexed<T extends AnyObject, R extends {
    [key in keyof T]: T[keyof T];
}>(predicate: (el: T[keyof T], key: keyof T) => boolean, obj: T): R;
//# sourceMappingURL=pickByIndexed.d.ts.map