import type { AnyObject } from './types';
/**
 * picks specified props only if they exist on the provided object
 * @example
 * pickOwn(['b'], { a: 1, b: 2 })
 * // returns { b: 2 }
 */
export default function pickOwn<Obj extends AnyObject, Prop extends keyof Obj>(props: Prop[], obj: Obj): Pick<Obj, Prop>;
//# sourceMappingURL=pickOwn.d.ts.map