import type { AnyObject } from './types';
/**
 * sets the property of the provided object specified by the provided path in form of a string or an array of keys
 * @example
 * const obj = { a: 1, b: { c: 2 } }
 * set('b.d', 3, obj)
 * // returns { a: 1, b: { c: 2, d: 3 } }
 * set(['b', 'd'], 3, obj)
 * // returns { a: 1, b: { c: 2, d: 3 } }
 */
export default function set<T extends AnyObject, V>(_keys: string | string[], val: V, obj: T): AnyObject;
//# sourceMappingURL=set.d.ts.map