import type { AnyObject, Prettify } from './types';
type IsEmptyObject<Obj extends AnyObject> = [keyof Obj] extends [never] ? true : false;
type Diff<Slice extends AnyObject, Obj extends AnyObject> = {
    [Key in keyof Obj as Key extends keyof Slice ? Slice[Key] extends Obj[Key] ? Obj[Key] extends Slice[Key] ? never : never : Key : never]: Slice[Key];
} & {
    [Key in keyof Slice as Key extends keyof Obj ? never : Key]: Slice[Key];
};
type SliceDiff<Slice extends AnyObject, Obj extends AnyObject> = IsEmptyObject<Diff<Slice, Obj>> extends false ? Prettify<Diff<Slice, Obj>> : null;
/**
 * returns the diff object from the provided object and slice comparison
 * @example
 * sliceDiff({ a: 1, b: 10, g: 3 }, { a: 1, b: 2, c: 3 })
 * // returns { b: 10, g: 3 }
 */
export default function sliceDiff<S extends AnyObject, T extends AnyObject>(slice: S, obj: T): SliceDiff<S, T>;
export {};
//# sourceMappingURL=sliceDiff.d.ts.map