import type { AnyFunction } from './types';
/**
 * ensures that a function is executed at a fixed interval, so that it is not called too frequently
 * @example
 * const updatePreview = () => { ... }
 * const throttledUpdatePreview = throttle(updatePreview, 500);
 * inputField.addEventListener('input', throttledUpdatePreview);
 */
export default function throttle(ms: number, fn: AnyFunction): {
    (...args: any[]): void;
    cancel: () => void;
};
//# sourceMappingURL=throttle.d.ts.map