import type { AnyObject } from './types';
/**
 * returns an array of derived from the provided object key-value tuples
 * @example
 * toPairs({ a: 1, b: 2 })
 * // returns [['a', 1], ['b', 2]]
 */
export default function toPairs<T extends AnyObject>(obj: T): {
    [K in keyof T]: [K, T[K]];
}[keyof T][];
//# sourceMappingURL=toPairs.d.ts.map