import type { AnyFunction } from './types';
/**
 * ensures that a function is executed at a fixed interval, so that it is not called too frequently
 * @example
 * const updatePreview = () => { ... }
 * const throttledUpdatePreview = trailingThrottle(updatePreview, 500);
 * inputField.addEventListener('input', throttledUpdatePreview);
 */
export default function trailingThrottle<T extends AnyFunction>(ms: number, fn: T): {
    (...args: Parameters<T>): void;
    cancel: () => void;
};
//# sourceMappingURL=trailingThrottle.d.ts.map